//////////////////////////////////////////////////////////////////////////
// $Id: Data.h,v 1.11 2005/07/11 20:23:12 klas Exp $
//
// Usage: Data class. inherited from Connection, everything pertaining to
//        data connection goes here.
//
//  A part of babyftpd, licensed under the GNU GPL, see the file
//    LICENSE for complete information.
//////////////////////////////////////////////////////////////////////////

#ifndef DATA_H
#define DATA_H

#ifdef DATA_CPP
#include "generic.h"
#include "Utilities.h"
#include "Configuration.h"
#include "Log.h"
#include "Connection.h"
#include "User.h"
#endif // DATA_CPP

class Data : public Connection
{
  private:
    void open_active();
    void open_passive();
  public:
    User *user;
    Data(User *user, int file_id = -1, string file_name = "",
        int trans_type = 0);
    ~Data();
    MEMBER(trans_type, int);
    MEMBER(file_id, int);
    MEMBER(file_name, string);
};

void kill_data(void*);

extern pthread_key_t my_data;

#endif // DATA_H
