/////////////////////////////////////////////////////////////////////
// $Id: Handler.h,v 1.53 2005/06/12 15:27:01 klas Exp $
//
// Usage: the main loop for connected clients and interpreter for
//        ftp commands.
//
//  A part of babyftpd, licensed under the GNU GPL, see the file
//    LICENSE for complete information.
/////////////////////////////////////////////////////////////////////

#ifndef HANDLER_H
#define HANDLER_H

#ifdef HANDLER_CPP
#include "generic.h"
#include "Utilities.h"
#include "Configuration.h"
#include "Log.h"
#include "Connection.h"
#include "Commands.h"
#include "User.h"
#include "StringTokenizer.h"
#endif

struct command_info {
  int ant_arg; //Number of arguments. -1 means variable size.
  bool (Commands::*pf)(User*, string&, unsigned int);
  unsigned int extra_flag; //extra flags that is needed by that function
  string hlp_info; // if this is empty, no help.
  // constructor for assigning the hash
  command_info(int a,
      bool (Commands::*p)(User*, string&, unsigned int),
      unsigned int e, string h)
  {
    ant_arg = a;
    pf = p;
    extra_flag = e;
    hlp_info = h;
  }
  // and one to make the hash functions happy that it still looks like a struct
  command_info() {};
};

class Handler
{
  private:
    bool interpreter(User*, string);
  public:
    Handler();
    ~Handler();
    bool init(User*);
    class User *initializer(int);
    hash_map<const char*, struct command_info, hash<const char*>,
      Utilities::eqstr> cmd_info;
};

extern class Handler *handler;

extern vector<User*> user_list;
extern pthread_rwlock_t user_list_lock;

#endif
