/////////////////////////////////////////////////////////////////////
//  $Id: Log.h,v 1.13 2005/08/23 19:34:02 klas Exp $
//
//  Usage: Logging defines, functions etc.
//
//  A part of babyftpd, licensed under the GNU GPL, see the file
//    LICENSE for complete information.
/////////////////////////////////////////////////////////////////////

#ifndef LOG_H
#define LOG_H

#ifdef LOG_CPP
#include "generic.h"
#include "Configuration.h"
#include "Utilities.h"
#endif // LOG_CPP

enum log_types { TYPE_XFER, TYPE_AUTH, TYPE_INFO, TYPE_DEBUG };

class Log
{
  private:
    vector<struct log_data> to_log;
    sem_t to_log_lock; // locking the vector when we push/pop it
    // these two are used to signal the logging thread it has data to pick up
    pthread_cond_t data_ready;
    pthread_mutex_t ready_mutex;
    void xferlog(struct log_data);
    void authlog(struct log_data);
    void infolog(struct log_data);
    void debuglog(struct log_data);

  public:
    void log_main(void);
    void log_this(int, enum log_types, string);
    Log(void);
    ~Log(void);
};

extern class Log *logging;

struct log_data
{
  int level;
  enum log_types type;
  string message;
};

#endif // LOG_H
