/////////////////////////////////////////////////////////////////////
// $Id: StringTokenizer.h,v 1.13 2005/04/12 21:18:06 klas Exp $
//
// Usage: Used to chop up a string in "tokens"
//
//  A part of babyftpd, licensed under the GNU GPL, see the file
//    LICENSE for complete information.
/////////////////////////////////////////////////////////////////////

#ifndef STRINGTOKENIZER_H
#define STRINGTOKENIZER_H

#ifdef STRINGTOKENIZER_CPP
#include "generic.h"
#include "Log.h"
#endif

class StringTokenizer
{
  public:
    StringTokenizer(string, string, bool);
    bool hasMoreTokens(void) const;
    string nextToken();
    int countTokens(void) const;
    string restTokens(void) const;

  private:
    string::const_iterator skipDelimiters(string::const_iterator) const;
    string::const_iterator scanToken(string::const_iterator) const;
    bool isDelimiter(char c) const
    { return(delimiters.find(c) == string::npos ? false : true ); }

    string::const_iterator currentPosition;
    string text;
    string delimiters;
    bool retDelims;
};

#endif
