/////////////////////////////////////////////////////////////////////
// $Id: User.h,v 1.100 2005/08/24 21:07:45 klas Exp $
//
// Usage: Holds information about connected users.
//
//  A part of babyftpd, licensed under the GNU GPL, see the file
//    LICENSE for complete information.
/////////////////////////////////////////////////////////////////////

#ifndef USER_H
#define USER_H

#ifdef USER_CPP
#include "generic.h"
#include "Utilities.h"
#include "Configuration.h"
#include "Log.h"
#include "Connection.h"
#include "Data.h"
#include "Commands.h"
#endif

enum logged { NOT_LOGGED_IN, USER_SUPPLIED, LOGGED_IN };

class User : public Connection
{
  public:
    User(int socket_id, struct sockaddr_in &addr);
    vector<Data*>::iterator get_data_it(pthread_t);
    User &operator>>(string &message);
    bool data_vec_full();
    bool login();
    ~User();
    vector<Data*> data_vec;
    MEMBER(logged_in, int);
    MEMBER(data_id, int);
    MEMBER(data_addr, struct sockaddr_in);
    MEMBER(current_dir, string);
    MEMBER(root_dir, string);
    MEMBER(temp_buf, string); // is this for anything but rename?
    MEMBER(failed_logins, int);
    MEMBER(pamh, pam_handle_t*);
    MEMBER(rest_pos, off_t);
    MEMBER(anonymous_id, string);
};

vector<User*>::iterator get_user_it(pthread_t);
void kill_user(void*);

extern pthread_key_t my_user;
extern pthread_rwlock_t user_list_lock;
extern vector<User*> user_list;

#endif // USER_H
