/////////////////////////////////////////////////////////////////////
// $Id: Utilities.h,v 1.33 2005/03/29 18:02:58 klas Exp $
//
// Usage: Various functions that doesn't belong anywhere else.
//
//  A part of babyftpd, licensed under the GNU GPL, see the file
//    LICENSE for complete information.
/////////////////////////////////////////////////////////////////////

#ifndef UTILITIES_H
#define UTILITIES_H

#ifdef UTILITIES_CPP
#include "generic.h"
#endif

class Utilities
{
  private:

  public:
    void strip_line_breaks(string&);
    int clean_string(string&);
    string itos(long long int);
    string parse_perms_ls(mode_t);
    string parse_perms_num(mode_t);
    int time_string(string&, string, size_t len = 50, time_t timep = 0);

    // small inline functions, previously macros
    bool is_set(unsigned int flag, unsigned int bit)
    { return(flag & bit); }
    void set_bit(unsigned int &flag, unsigned int bit)
    { flag |= bit; }
    void remove_bit(unsigned int &flag, unsigned int bit)
    { flag &= ~bit; }
    void toggle_bit(unsigned int &flag, unsigned int bit)
    { flag ^= bit;  }
    struct eqstr
    {
      bool operator()(const char *s1, const char *s2)
      { return strcmp(s1, s2) == 0; }
    };
};

extern class Utilities util;

#endif
