/////////////////////////////////////////////////////////////////////
// $Id: babyftpd.h,v 1.58 2005/08/23 19:34:02 klas Exp $
//
// Usage: main function, commandline parsing and function that
//        on the main socket.
//
//  A part of babyftpd, licensed under the GNU GPL, see the file
//    LICENSE for complete information.
/////////////////////////////////////////////////////////////////////

#ifndef BABYFTPD_H
#define BABYFTPD_H

#ifdef BABYFTPD_CPP
#include "generic.h"
#include "Utilities.h"
#include "Configuration.h"
#include "Log.h"
#include "Connection.h"
#include "User.h"
#include "Data.h"
#include "Handler.h"
#include "Commands.h"
#ifdef USE_TLS
#include "tls.cpp"
#endif // USE_TLS
#endif // BABYFTPD_CPP

static void *user_wrapper(void*) __attribute__ ((noreturn));
static void *log_wrapper(void*) __attribute__ ((noreturn));
bool listener(void);
void sig_handler(int);
void exit_baby(int, enum exits);
void lifebeat(void);

// thread specific storage..
pthread_key_t my_user = 0;
pthread_key_t my_data = 0;

pthread_rwlock_t user_list_lock;
sem_t cleanup_list_lock;
pthread_t main_thread; // for managing on shutdown and signal handling.
pthread_t logging_thread; // so we can join it.
vector<User*> user_list;
vector<pthread_t> cleanup_list;

const int LISTEN_LIMIT = 5;

#ifdef USE_TLS
gnutls_certificate_credentials x509_cred;
static gnutls_dh_params dh_params;
time_t dh_time;
int tls_db_store(void*, gnutls_datum, gnutls_datum);
gnutls_datum tls_db_fetch(void*, gnutls_datum);
int tls_db_delete(void*, gnutls_datum);

struct cache
{
  gnutls_datum key;
  gnutls_datum data;
};

vector<cache*> cache_db;
pthread_rwlock_t cache_lock;
#endif // USE_TLS

#endif
