#!/usr/bin/perl -w
# $Id: verify_client.pl,v 1.5 2005/04/09 16:03:40 klas Exp $

# small example script included with babyftpd to show how you can match
# certificates to usernames. The certificate is already validated against your
# loaded ca's, this is just to check the mapping to user.

# the daemon will give us 4 commandline parameters:
#   username of the user attempting to login
#   hostname or ip of the client
#            (yes, it can be either, at the time of writing it is always ip
#            but I mean to fix that.)
#   dn of the ca that has issued the certificate that is used
#   dn of the certificate

# Note1: this example doesn't make use of hostname or ca dn. (args 2 and 3).

# Note2: this way of matching dn -> user only allows for each dn to be used
#        once. If you want to be able to allow a certificate to login as
#        several users you need to come up with something more clever.

use strict;

(scalar(@ARGV) == 4) or die;

my $user;
my $hostname;
my $ca_dn;
my $user_dn;

($user, $hostname, $ca_dn, $user_dn) = @ARGV;

my %users =
(
  "C=SE,O=gablorg,CN=berra Bertil Bertilsson,UID=1001" => "berra",
  "C=SE,O=gablorg,CN=bosse Bo Bergman,UID=1002" => "bosse",
);
my $exit = 1;

if(defined($users{$user_dn}) && $users{$user_dn} eq $user)
{
  $exit = 0;
}

exit $exit;
