/////////////////////////////////////////////////////////////////////
// $Id: tls.cpp,v 1.2 2005/02/14 21:48:27 klas Exp $
//
// Shamelessly ripped code from gcrypt.h, modified for c++.
//   Included when we have new gcrypt and need to tell it how to do
//   thread locking for us.
//
// A part of babyftpd, licensed under the GNU GPL, see the file
//   LICENSE for complete information.
//
////////////////////////////////////////////////////////////////////

#define TLS_CPP
#ifndef OLD_GCRYPT

static int gcry_pthread_mutex_init (void **priv)
{
  int err = 0;
  pthread_mutex_t *lock = new pthread_mutex_t;
  if (!lock)
    err = ENOMEM;
  if (!err)
  {
    err = pthread_mutex_init (lock, NULL);
    if (err)
      delete lock;
    else
      *priv = lock;
  }
  return err;
}

static int gcry_pthread_mutex_destroy (void **lock)
{
  pthread_mutex_t *temp_lock = (static_cast<pthread_mutex_t*>(*lock));
  int err = pthread_mutex_destroy(temp_lock);
  delete temp_lock;
  return err;
}

static int gcry_pthread_mutex_lock (void **lock)
{
  pthread_mutex_t *temp_lock = (static_cast<pthread_mutex_t*>(*lock));
  return pthread_mutex_lock(temp_lock);
}

static int gcry_pthread_mutex_unlock (void **lock)
{
  pthread_mutex_t *temp_lock = (static_cast<pthread_mutex_t*>(*lock));
  return pthread_mutex_unlock(temp_lock);
}

static struct gcry_thread_cbs gcry_threads_pthread =
{
  GCRY_THREAD_OPTION_PTHREAD, NULL,
  gcry_pthread_mutex_init, gcry_pthread_mutex_destroy,
  gcry_pthread_mutex_lock, gcry_pthread_mutex_unlock
};

#endif // OLD_GCRYPT
